package xn.update;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.widget.EditText;

import androidx.activity.EdgeToEdge;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.blankj.utilcode.util.ActivityUtils;
import com.blankj.utilcode.util.AppUtils;
import com.blankj.utilcode.util.SPUtils;
import com.blankj.utilcode.util.ToastUtils;
import com.lxj.xpopup.XPopup;
import com.lxj.xpopup.impl.InputConfirmPopupView;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import xn.update.constant.AppConstant;
import xn.update.databinding.ActivityMainBinding;
import xn.update.evnet.UpdateUiEvent;

public class MainActivity extends AppCompatActivity {
    private ActivityMainBinding binding;
    private InputConfirmPopupView inputConfirmPopupView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        if (!EventBus.getDefault().isRegistered(this)) {
            EventBus.getDefault().register(this);
        }
        // 启动后台任务
        Tool.INSTANCE.startTaskService();
        // 先启动主应用
        Tool.INSTANCE.openApp("xn.xxp");

        binding = ActivityMainBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
    }

    @Override
    protected void onPostCreate(@Nullable Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);
        binding.versionNameTV.setText(AppUtils.getAppVersionName());
        inputConfirmPopupView = new XPopup.Builder(this).autoDismiss(false).asInputConfirm("Tips", "请输入管理员密码",
                text -> {
                    if (text.equals(SPUtils.getInstance().getString(AppConstant.ADMIN_PASSWORD, "admin@098&"))) {
                        ActivityUtils.startActivity(SettingActivity.class);
                        inputConfirmPopupView.dismiss();
                    } else {
                        ToastUtils.showLong("密码不正确,请重新输入!");
                    }
                });
        binding.logoIV.setOnLongClickListener(v -> {
            if (AppUtils.isAppDebug()) {
                ActivityUtils.startActivity(SettingActivity.class);
            } else {
                EditText editText = inputConfirmPopupView.getEditText();
                if (null != editText) {
                    editText.setText("");
                }
                inputConfirmPopupView.show();
            }
            return true;
        });

    }

    @Subscribe(threadMode = ThreadMode.MAIN)
    public void onMessageEvent(UpdateUiEvent event) {
        binding.tipsTV.setText(event.getMsg());
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (!EventBus.getDefault().isRegistered(this)) {
            EventBus.getDefault().register(this);
        }
    }

    @SuppressLint("MissingSuperCall")
    @Override
    public void onBackPressed() {
    }
}